/*! 
*  \file hmi_driver.h
*  \brief ָദ
*  \version 1.0
*  \date 2012-2018
*  \copyright ݴʹƼ޹˾
*/


#ifndef _CMD_PROCESS_H
#define _CMD_PROCESS_H
#include "hmi_driver.h"


#define NOTIFY_TOUCH_PRESS         0X01  //֪ͨ
#define NOTIFY_TOUCH_RELEASE       0X03  //ɿ֪ͨ
#define NOTIFY_WRITE_FLASH_OK      0X0C  //дFLASHɹ
#define NOTIFY_WRITE_FLASH_FAILD   0X0D  //дFLASHʧ
#define NOTIFY_READ_FLASH_OK       0X0B  //FLASHɹ
#define NOTIFY_READ_FLASH_FAILD    0X0F  //FLASHʧ
#define NOTIFY_MENU                0X14  //˵¼֪ͨ
#define NOTIFY_TIMER               0X43  //ʱʱ֪ͨ
#define NOTIFY_CONTROL             0XB1  //ؼ֪ͨ
#define NOTIFY_READ_RTC            0XF7  //ȡRTCʱ
#define MSG_GET_CURRENT_SCREEN     0X01  //ID仯֪ͨ
#define MSG_GET_DATA               0X11  //ؼ֪ͨ
#define NOTIFY_HandShake           0X55  //֪ͨ

#define PTR2U16(PTR) ((((uint8 *)(PTR))[0]<<8)|((uint8 *)(PTR))[1])  //ӻȡ16λ
#define PTR2U32(PTR) ((((uint8 *)(PTR))[0]<<24)|(((uint8 *)(PTR))[1]<<16)|(((uint8 *)(PTR))[2]<<8)|((uint8 *)(PTR))[3])  //ӻȡ32λ


enum CtrlType
{
    kCtrlUnknown=0x0,
    kCtrlButton=0x10,                     //ť
    kCtrlText,                            //ı
    kCtrlProgress,                        //
    kCtrlSlider,                          //
    kCtrlMeter,                            //Ǳ
    kCtrlDropList,                        //б
    kCtrlAnimation,                       //
    kCtrlRTC,                             //ʱʾ
    kCtrlGraph,                           //ͼؼ
    kCtrlTable,                           //ؼ
    kCtrlMenu,                            //˵ؼ
    kCtrlSelector,                        //ѡؼ
    kCtrlQRCode,                          //ά
};

#pragma pack(push)
#pragma pack(1)                           //ֽڶ

typedef struct
{
    uint8    cmd_head;                    //֡ͷ

    uint8    cmd_type;                    //(UPDATE_CONTROL)    
    uint8    ctrl_msg;                    //CtrlMsgType-ָʾϢ
    uint16   screen_id;                   //ϢĻID
    uint16   control_id;                  //ϢĿؼID
    uint8    control_type;                //ؼ

    uint8    param[256];                  //ɱ䳤Ȳ256ֽ

    uint8  cmd_tail[4];                   //֡β
}CTRL_MSG,*PCTRL_MSG;

#pragma pack(pop)

/*! 
*  \brief  ֪ͨ
*/
void NOTIFYHandShake();

/*! 
*  \brief  Ϣ
*  \param msg Ϣ
*  \param size Ϣ
*/
void ProcessMessage( PCTRL_MSG msg, uint16 size );
/*! 
*  \brief  л֪ͨ
*  \details  ǰıʱ(GetScreen)ִд˺
*  \param screen_id ǰID
*/
void NotifyScreen(uint16 screen_id);
/*! 
*  \brief  ¼Ӧ
*  \param press 1´3ɿ
*  \param x x
*  \param y y
*/
void NotifyTouchXY(uint8 press,uint16 x,uint16 y);

/*! 
*  \brief  ťؼ֪ͨ
*  \details  ť״̬ı(GetControlValue)ʱִд˺
*  \param screen_id ID
*  \param control_id ؼID
*  \param state ť״̬01
*/
void NotifyButton(uint16 screen_id, uint16 control_id, uint8 state);
/*! 
*  \brief  ıؼ֪ͨ
*  \details  ı̸ͨ(GetControlValue)ʱִд˺
*  \details  ıؼַʽ·MCUıؼǸֵ
*  \details  Ҫڴ˺н·ַתظֵ
*  \param screen_id ID
*  \param control_id ؼID
*  \param str ıؼ
*/
void NotifyText(uint16 screen_id, uint16 control_id, uint8 *str);
/*!                                                                              
*  \brief  ؼ֪ͨ                                                       
*  \details  GetControlValueʱִд˺                                  
*  \param screen_id ID                                                      
*  \param control_id ؼID                                                     
*  \param value ֵ                                                              
*/   
void NotifyProgress(uint16 screen_id, uint16 control_id, uint32 value);
/*!                                                                              
*  \brief  ؼ֪ͨ                                                       
*  \details  ı(GetControlValue)ʱִд˺                  
*  \param screen_id ID                                                      
*  \param control_id ؼID                                                     
*  \param value ֵ                                                              
*/    
void NotifySlider(uint16 screen_id, uint16 control_id, uint32 value);
/*! 
*  \brief  Ǳؼ֪ͨ
*  \details  GetControlValueʱִд˺
*  \param screen_id ID
*  \param control_id ؼID
*  \param value ֵ
*/
void NotifyMeter(uint16 screen_id, uint16 control_id, uint32 value);
/*! 
*  \brief  ˵ؼ֪ͨ
*  \details  ˵»ɿʱִд˺
*  \param screen_id ID
*  \param control_id ؼID
*  \param item ˵
*  \param state ť״̬0ɿ1
*/
void NotifyMenu(uint16 screen_id, uint16 control_id, uint8  item, uint8  state);

/*! 
*  \brief  ѡؼ֪ͨ
*  \details  ѡؼ仯ʱִд˺
*  \param screen_id ID
*  \param control_id ؼID
*  \param item ǰѡ
*/
void NotifySelector(uint16 screen_id, uint16 control_id, uint8  item);
/*! 
*  \brief  ʱʱ֪ͨ
*  \param screen_id ID
*  \param control_id ؼID
*/
void NotifyTimer(uint16 screen_id, uint16 control_id);
/*! 
*  \brief  ȡûFLASH״̬
*  \param status 0ʧܣ1ɹ
*  \param _data 
*  \param length ݳ
*/
void NotifyReadFlash(uint8 status,uint8 *_data,uint16 length);

/*! 
*  \brief  дûFLASH״̬
*  \param status 0ʧܣ1ɹ
*/
void NotifyWriteFlash(uint8 status);
/*! 
*  \brief  ȡRTCʱ䣬עⷵصBCD
*  \param year ꣨BCD
*  \param month £BCD
*  \param week ڣBCD
*  \param day գBCD
*  \param hour ʱBCD
*  \param minute ֣BCD
*  \param second 루BCD
*/
void NotifyReadRTC(uint8 year,uint8 month,uint8 week,uint8 day,uint8 hour,uint8 minute,uint8 second);

#endif
