/*! 
*  \file hmi_driver.h
*  \brief ļ
*  \version 1.0
*  \date 2012-2018
*  \copyright ݴʹƼ޹˾
*/

#ifndef _HMI_DRIVER_
#define _HMI_DRIVER_

#define FIRMWARE_VER 921          // ִ˹̼汾ʵĻһ£ȷܿ
#define CRC16_ENABLE 0            // ҪCRC16У鹦ܣ޸Ĵ˺Ϊ1(ʱҪVisualTFTCRCУ)
#define CMD_MAX_SIZE 64           // ָСҪôһЩ
#define QUEUE_MAX_SIZE 512        // ָջСҪôһЩ

#define SD_FILE_EN 0

#include "hmi_user_uart.h"

/*! 
*  \brief  ǷCRC16У
*  \param buffer Уݣĩβ洢CRC16
*  \param n ݳȣCRC16
*  \return Уͨ1򷵻0
*/
uint16 CheckCRC16(uint8 *buffer,uint16 n);

/*! 
*  \brief  ʱ
*  \param  n ʱʱ(뵥λ)
*/
void DelayMS(unsigned int n);

/*! 
*  \brief  豸ã֮Ҫ޸Ĳʡʽ
*/
void LockDeviceConfig(void);

/*! 
*  \brief  豸
*/
void UnlockDeviceConfig(void);

/*! 
*  \brief    ޸ĴĲ
*  \details  ѡΧ[0~14]Ӧʵʲ
{1200,2400,4800,9600,19200,38400,57600,115200,1000000,2000000,218750,437500,875000,921800,2500000}
*  \param  option ѡ
*/
void SetCommBps(uint8 option);

/*! 
*  \brief  
*/
void SetHandShake(void);

/*! 
*  \brief  ǰɫ
*  \param  color ǰɫ
*/
void SetFcolor(uint16 color);

/*! 
*  \brief  ñɫ
*  \param  color ɫ
*/
void SetBcolor(uint16 color);

/*! 
*  \brief  
*/
void GUI_CleanScreen();

/*! 
*  \brief  ּ
*  \param  x_w 
*  \param  y_w 
*/
void SetTextSpace(uint8 x_w, uint8 y_w);

/*! 
*  \brief  ʾ
*  \param  enable Ƿ
*  \param  width 
*  \param  height ߶
*/
void SetFont_Region(uint8 enable,uint16 width,uint16 height );

/*! 
*  \brief  ùɫ
*  \param  fillcolor_dwon ɫ½
*  \param  fillcolor_up ɫϽ
*/
void SetFilterColor(uint16 fillcolor_dwon, uint16 fillcolor_up);

/*! 
*  \brief  ùɫ
*  \param  x λX
*  \param  y λY
*  \param  back ɫϽ
*  \param  font 
*  \param  strings ַ
*/
void DisText(uint16 x, uint16 y,uint8 back,uint8 font,uchar *strings );

/*! 
*  \brief    ʾ
*  \param  enable Ƿʾ
*  \param  x λX
*  \param  y λY
*  \param  width 
*  \param  height ߶
*/
void DisCursor(uint8 enable,uint16 x, uint16 y,uint8 width,uint8 height );

/*! 
*  \brief      ʾȫͼƬ
*  \param  image_id ͼƬ
*  \param  masken Ƿ͸
*/
void DisFull_Image(uint16 image_id,uint8 masken);

/*! 
*  \brief      ָλʾͼƬ
*  \param  x λX
*  \param  y λY
*  \param  image_id ͼƬ
*  \param  masken Ƿ͸
*/
void DisArea_Image(uint16 x,uint16 y,uint16 image_id,uint8 masken);

/*! 
*  \brief      ʾüͼƬ
*  \param  x λX
*  \param  y λY
*  \param  image_id ͼƬ
*  \param  image_x ͼƬüλX
*  \param  image_y ͼƬüλY
*  \param  image_l ͼƬü
*  \param  image_w ͼƬü߶
*  \param  masken Ƿ͸
*/
void DisCut_Image(uint16 x,uint16 y,uint16 image_id,uint16 image_x,uint16 image_y,
				  uint16 image_l, uint16 image_w,uint8 masken);

/*! 
*  \brief      ʾGIF
*  \param  x λX
*  \param  y λY
*  \param  flashimage_id ͼƬ
*  \param  enable Ƿʾ
*  \param  playnum Ŵ
*/
void DisFlashImage(uint16 x,uint16 y,uint16 flashimage_id,uint8 enable,uint8 playnum);

/*! 
*  \brief      
*  \param  x λX
*  \param  y λY
*/
void GUI_Dot(uint16 x,uint16 y);

/*! 
*  \brief      
*  \param  x0 ʼλX
*  \param  y0 ʼλY
*  \param  x1 λX
*  \param  y1 λY
*/
void GUI_Line(uint16 x0, uint16 y0, uint16 x1, uint16 y1);

/*! 
*  \brief      
*  \param  mode ģʽ
*  \param  dot ݵ
*  \param  dot_cnt 
*/
void GUI_ConDots(uint8 mode,uint16 *dot,uint16 dot_cnt);

/*! 
*  \brief      Բ
*  \param  x0 ԲλX
*  \param  y0 ԲλY
*  \param  r 뾶
*/
void GUI_Circle(uint16 x0, uint16 y0, uint16 r);

/*! 
*  \brief      ʵԲ
*  \param  x0 ԲλX
*  \param  y0 ԲλY
*  \param  r 뾶
*/
void GUI_CircleFill(uint16 x0, uint16 y0, uint16 r);

/*! 
*  \brief      
*  \param  x0 ԲλX
*  \param  y0 ԲλY
*  \param  r 뾶
*  \param  sa ʼǶ
*  \param  ea ֹǶ
*/
void GUI_Arc(uint16 x,uint16 y, uint16 r,uint16 sa, uint16 ea);

/*! 
*  \brief      ľ
*  \param  x0 ʼλX
*  \param  y0 ʼλY
*  \param  x1 λX
*  \param  y1 λY
*/
void GUI_Rectangle(uint16 x0, uint16 y0, uint16 x1,uint16 y1 );

/*! 
*  \brief      ʵľ
*  \param  x0 ʼλX
*  \param  y0 ʼλY
*  \param  x1 λX
*  \param  y1 λY
*/
void GUI_RectangleFill(uint16 x0, uint16 y0, uint16 x1,uint16 y1 );

/*! 
*  \brief      Բ
*  \param  x0 ʼλX
*  \param  y0 ʼλY
*  \param  x1 λX
*  \param  y1 λY
*/
void GUI_Ellipse (uint16 x0, uint16 y0, uint16 x1,uint16 y1 );

/*! 
*  \brief      ʵԲ
*  \param  x0 ʼλX
*  \param  y0 ʼλY
*  \param  x1 λX
*  \param  y1 λY
*/
void GUI_EllipseFill (uint16 x0, uint16 y0, uint16 x1,uint16 y1 );

/*! 
*  \brief      
*  \param  x0 ʼλX
*  \param  y0 ʼλY
*  \param  x1 λX
*  \param  y1 λY
*/
void SetBackLight(uint8 light_level);

/*! 
*  \brief   
*  \time  time ʱ(뵥λ)
*/
void SetBuzzer(uint8 time);

/*! 
*  \brief   
*  \param enable ʹ
*  \param beep_on 
*  \param work_mode ģʽ0¾ϴ1ɿϴ2ϴֵ3ºɿϴ
*  \param press_calibration 20У׼0ã1
*/
void SetTouchPaneOption(uint8 enbale,uint8 beep_on,uint8 work_mode,uint8 press_calibration);

/*! 
*  \brief   У׼
*/
void	CalibrateTouchPane();

/*! 
*  \brief  
*/
void TestTouchPane();

/*! 
*  \brief      õǰдͼ
*  \details  һʵ˫Ч(ͼʱ˸)
*  \details  uint8 layer = 0;
*  \details  WriteLayer(layer);   д
*  \details  ClearLayer(layer);   ʹͼ͸
*  \details  һϵлͼָ
*  \details  DisText(100,100,0,4,"hello hmi!!!");
*  \details  DisplyLayer(layer);  лʾ
*  \details  layer = (layer+1)%2; ˫л
*  \see DisplyLayer
*  \see ClearLayer
*  \param  layer ͼ
*/
void WriteLayer(uint8 layer);

/*! 
*  \brief      õǰʾͼ
*  \param  layer ͼ
*/
void DisplyLayer(uint8 layer);

/*! 
*  \brief      ͼ㣬ʹͼ͸
*  \param  layer ͼ
*/
void ClearLayer(uint8 layer);

/*! 
*  \brief  дݵû洢
*  \param  startAddress ʼַ
*  \param  length ֽ
*  \param  _data д
*/
void WriteUserFlash(uint32 startAddress,uint16 length,uint8 *_data);

/*! 
*  \brief  Ӵû洢ȡ
*  \param  startAddress ʼַ
*  \param  length ֽ
*/
void ReadUserFlash(uint32 startAddress,uint16 length);

/*! 
*  \brief      ͼ
*  \param  src_layer ԭʼͼ
*  \param  dest_layer Ŀͼ
*/
void CopyLayer(uint8 src_layer,uint8 dest_layer);

/*! 
*  \brief      õǰ
*  \param  screen_id ID
*/
void SetScreen(uint16 screen_id);

/*! 
*  \brief      ȡǰ
*/
void GetScreen(uint16 screen_id);

/*! 
*  \brief     \û
*  \details \һɶʹãڱ˸ˢٶ
*  \details ÷
*	\details SetScreenUpdateEnable(0);//ֹ
*	\details һϵи»ָ
*	\details SetScreenUpdateEnable(1);//
*  \param  enable 0ã1
*/
void SetScreenUpdateEnable(uint8 enable);

/*! 
*  \brief     ÿؼ뽹
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  focus Ƿ뽹
*/
void SetControlFocus(uint16 screen_id,uint16 control_id,uint8 focus);

/*! 
*  \brief     ʾ\ؿؼ
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  visible Ƿʾ
*/
void SetControlVisiable(uint16 screen_id,uint16 control_id,uint8 visible);

/*! 
*  \brief     ôؼʹ
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  enable ؼǷʹ
*/
void SetControlEnable(uint16 screen_id,uint16 control_id,uint8 enable);

/*! 
*  \brief     ȡؼֵ
*  \param  screen_id ID
*  \param  control_id ؼID
*/
void GetControlValue(uint16 screen_id,uint16 control_id);

/*! 
*  \brief     ðť״̬
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  value ť״̬
*/
void SetButtonValue(uint16 screen_id,uint16 control_id,uchar value);

/*! 
*  \brief     ıֵ
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  str ıֵ
*/
void SetTextValue(uint16 screen_id,uint16 control_id,uchar *str);

#if FIRMWARE_VER>=908

/*! 
*  \brief     ıΪֵҪFIRMWARE_VER>=908
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  value ıֵ
*  \param  sign 0-޷ţ1-з
*  \param  fill_zero λʱಹ
*/
void SetTextInt32(uint16 screen_id,uint16 control_id,uint32 value,uint8 sign,uint8 fill_zero);

/*! 
*  \brief     ıȸֵҪFIRMWARE_VER>=908
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  value ıֵ
*  \param  precision Сλ
*  \param  show_zeros Ϊ1ʱʾĩβ0
*/
void SetTextFloat(uint16 screen_id,uint16 control_id,float value,uint8 precision,uint8 show_zeros);

#endif

/*! 
*  \brief      ýֵ
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  value ֵ
*/
void SetProgressValue(uint16 screen_id,uint16 control_id,uint32 value);

/*! 
*  \brief     Ǳֵ
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  value ֵ
*/
void SetMeterValue(uint16 screen_id,uint16 control_id,uint32 value);

/*! 
*  \brief     Ǳֵ
*  \param  screen_id ID
*  \param  control_id ͼƬؼID
*  \param  value ֵ
*/
void Set_picMeterValue(uint16 screen_id,uint16 control_id,uint16 value);

/*! 
*  \brief      û
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  value ֵ
*/

void SetSliderValue(uint16 screen_id,uint16 control_id,uint32 value);

/*! 
*  \brief      ѡؼ
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  item ǰѡ
*/
void SetSelectorValue(uint16 screen_id,uint16 control_id,uint8 item);

/*! 
*  \brief      ʼŶ
*  \param  screen_id ID
*  \param  control_id ؼID
*/
void AnimationStart(uint16 screen_id,uint16 control_id);

/*! 
*  \brief      ֹͣŶ
*  \param  screen_id ID
*  \param  control_id ؼID
*/
void AnimationStop(uint16 screen_id,uint16 control_id);

/*! 
*  \brief      ͣŶ
*  \param  screen_id ID
*  \param  control_id ؼID
*/
void AnimationPause(uint16 screen_id,uint16 control_id);

/*! 
*  \brief     ƶ֡
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  frame_id ֡ID
*/
void AnimationPlayFrame(uint16 screen_id,uint16 control_id,uint8 frame_id);

/*! 
*  \brief     һ֡
*  \param  screen_id ID
*  \param  control_id ؼID
*/
void AnimationPlayPrev(uint16 screen_id,uint16 control_id);

/*! 
*  \brief     һ֡
*  \param  screen_id ID
*  \param  control_id ؼID
*/
void AnimationPlayNext(uint16 screen_id,uint16 control_id);

/*! 
*  \brief     ߿ؼ-ͨ
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  channel ͨ
*  \param  color ɫ
*/
void GraphChannelAdd(uint16 screen_id,uint16 control_id,uint8 channel,uint16 color);

/*! 
*  \brief     ߿ؼ-ɾͨ
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  channel ͨ
*/
void GraphChannelDel(uint16 screen_id,uint16 control_id,uint8 channel);

/*! 
*  \brief     ߿ؼ-
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  channel ͨ
*  \param  pData 
*  \param  nDataLen ݸ
*/
void GraphChannelDataAdd(uint16 screen_id,uint16 control_id,uint8 channel,uint8 *pData,uint16 nDataLen);

/*! 
*  \brief     ߿ؼ-
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  channel ͨ
*/
void GraphChannelDataClear(uint16 screen_id,uint16 control_id,uint8 channel);

/*! 
*  \brief     ߿ؼ-ͼ
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  x_offset ˮƽƫ
*  \param  x_mul ˮƽϵ
*  \param  y_offset ֱƫ
*  \param  y_mul ֱϵ
*/
void GraphSetViewport(uint16 screen_id,uint16 control_id,int16 x_offset,uint16 x_mul,int16 y_offset,uint16 y_mul);

/*! 
*  \brief     ʼ
*  \param  screen_id ID
*/
void BatchBegin(uint16 screen_id);

/*! 
*  \brief     °ťؼ
*  \param  control_id ؼID
*  \param  value ֵ
*/
void BatchSetButtonValue(uint16 control_id,uint8 state);

/*! 
*  \brief     ½ؼ
*  \param  control_id ؼID
*  \param  value ֵ
*/
void BatchSetProgressValue(uint16 control_id,uint32 value);

/*! 
*  \brief     »ؼ
*  \param  control_id ؼID
*  \param  value ֵ
*/
void BatchSetSliderValue(uint16 control_id,uint32 value);

/*! 
*  \brief     Ǳؼ
*  \param  control_id ؼID
*  \param  value ֵ
*/
void BatchSetMeterValue(uint16 control_id,uint32 value);

/*! 
*  \brief      ַ
*/
uint32 GetStringLen(uchar *str);

/*! 
*  \brief     ıؼ
*  \param  control_id ؼID
*  \param  strings ַ
*/
void BatchSetText(uint16 control_id,uchar *strings);

/*! 
*  \brief     ¶\ͼؼ
*  \param  control_id ؼID
*  \param  frame_id ֡ID
*/
void BatchSetFrame(uint16 control_id,uint16 frame_id);

#if FIRMWARE_VER>=921

/*! 
*  \brief     ÿؼɼ
*  \param  control_id ؼID
*  \param  visible ֡ID
*/
void BatchSetVisible(uint16 control_id,uint8 visible);

/*! 
*  \brief     ÿؼʹ
*  \param  control_id ؼID
*  \param  enable ֡ID
*/
void BatchSetEnable(uint16 control_id,uint8 enable);

#endif

/*! 
*  \brief    
*/
void BatchEnd();

/*! 
*  \brief     õʱؼ
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  timeout ʱ()
*/
void SeTimer(uint16 screen_id,uint16 control_id,uint32 timeout);

/*! 
*  \brief     ʱؼ
*  \param  screen_id ID
*  \param  control_id ؼID
*/
void StartTimer(uint16 screen_id,uint16 control_id);

/*! 
*  \brief     ֹͣʱؼ
*  \param  screen_id ID
*  \param  control_id ؼID
*/
void StopTimer(uint16 screen_id,uint16 control_id);

/*! 
*  \brief     ͣʱؼ
*  \param  screen_id ID
*  \param  control_id ؼID
*/
void PauseTimer(uint16 screen_id,uint16 control_id);

/*! 
*  \brief     ÿؼɫ
*  \details  ֿ֧ؼı
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  color ɫ
*/
void SetControlBackColor(uint16 screen_id,uint16 control_id,uint16 color);

/*! 
*  \brief     ÿؼǰɫ
* \details  ֿ֧ؼ
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  color ǰɫ
*/
void SetControlForeColor(uint16 screen_id,uint16 control_id,uint16 color);

/*! 
*  \brief     ʾ\ص˵ؼ
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  show ǷʾΪ0ʱfocus_control_idЧ
*  \param  focus_control_id ıؼ(˵ؼıؼ)
*/
void ShowPopupMenu(uint16 screen_id,uint16 control_id,uint8 show,uint16 focus_control_id);

/*! 
*  \brief     ʾ\ϵͳ
*  \param  show 0أ1ʾ
*  \param  x ʾλX
*  \param  y ʾλY
*  \param  type 0С̣1ȫ
*  \param  option 0ַ1룬2ʱ
*  \param  max_len ¼ַ
*/
void ShowKeyboard(uint8 show,uint16 x,uint16 y,uint8 type,uint8 option,uint8 max_len);

#if FIRMWARE_VER>=914
/*! 
*  \brief     
*  \param  ui_lang û0~9
*  \param  sys_lang ϵͳ-0ģ1Ӣ
*/
void SetLanguage(uint8 ui_lang,uint8 sys_lang);
#endif

#if FIRMWARE_VER>=917
/*! 
*  \brief     ʼؼֵFLASH
*  \param  version ݰ汾ţָ16λΪ汾ţ16λΪΰ汾
*  \param  address û洢Ĵŵַעַֹصͻ
*/
void FlashBeginSaveControl(uint32 version,uint32 address);

/*! 
*  \brief     ĳؼֵFLASH
*  \param  screen_id ID
*  \param  control_id ؼID
*/
void FlashSaveControl(uint16 screen_id,uint16 control_id);

/*! 
*  \brief     
*/
void FlashEndSaveControl();

/*! 
*  \brief     FLASHлָؼ
*  \param  version ݰ汾ţ汾ű洢ʱһ£ʧ
*  \param  address û洢Ĵŵַ
*/
void FlashRestoreControl(uint32 version,uint32 address);
#endif

#if FIRMWARE_VER>=921
/*! 
*  \brief     ʷֵ߲(ֽڣuint8int8)
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  value 
*  \param  channel ͨ
*/
void HistoryGraph_SetValueInt8(uint16 screen_id,uint16 control_id,uint8 *value,uint8 channel);

/*! 
*  \brief     ʷֵ߲(˫ֽڣuint16int16)
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  value 
*  \param  channel ͨ
*/
void HistoryGraph_SetValueInt16(uint16 screen_id,uint16 control_id,uint16 *value,uint8 channel);

/*! 
*  \brief     ʷֵ߲(ֽڣuint32int32)
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  value 
*  \param  channel ͨ
*/
void HistoryGraph_SetValueInt32(uint16 screen_id,uint16 control_id,uint32 *value,uint8 channel);

/*! 
*  \brief     ʷֵ߲(ȸ)
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  value 
*  \param  channel ͨ
*/
void HistoryGraph_SetValueFloat(uint16 screen_id,uint16 control_id,float *value,uint8 channel);

/*! 
*  \brief     ֹʷ߲
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  enable 0-ֹ1-
*/
void HistoryGraph_EnableSampling(uint16 screen_id,uint16 control_id,uint8 enable);

/*! 
*  \brief     ʾʷͨ
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  channel ͨ
*  \param  show 0-أ1-ʾ
*/
void HistoryGraph_ShowChannel(uint16 screen_id,uint16 control_id,uint8 channel,uint8 show);


/*! 
*  \brief     ʷʱ䳤()
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  sample_count һʾĲ
*/
void HistoryGraph_SetTimeLength(uint16 screen_id,uint16 control_id,uint16 sample_count);

/*! 
*  \brief     ʷŵȫ
*  \param  screen_id ID
*  \param  control_id ؼID
*/
void HistoryGraph_SetTimeFullScreen(uint16 screen_id,uint16 control_id);

/*! 
*  \brief     ʷűϵ
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  zoom Űٷֱ(zoom>100%ʱˮƽСŴ)
*  \param  max_zoom ƣһʾ
*  \param  min_zoom ƣһʾ
*/
void HistoryGraph_SetTimeZoom(uint16 screen_id,uint16 control_id,uint16 zoom,uint16 max_zoom,uint16 min_zoom);
#endif

#if SD_FILE_EN
/*! 
*  \brief     SDǷ
*/
void SD_IsInsert(void);

#define	FA_READ				   0x01  // ɶȡ
#define	FA_WRITE			   0x02  // д
#define	FA_CREATE_NEW		   0x04  // ļļѾڣ򷵻ʧ
#define	FA_CREATE_ALWAYS	   0x08  // ļļѾڣ򸲸
#define	FA_OPEN_EXISTING	   0x00  // ļļڣ򷵻ʧ
#define	FA_OPEN_ALWAYS		   0x10  // ļļڣ򴴽ļ

/*! 
*  \brief     򿪻򴴽ļ
*  \param  filename ļ(ASCII)
*  \param  mode ģʽѡģʽFA_XXXX
*/
void SD_CreateFile(uint8 *filename,uint8 mode);

/*! 
*  \brief     Եǰʱ䴴ļ:20161015083000.txt
*  \param  ext ļ׺ txt
*/
void SD_CreateFileByTime(uint8 *ext);

/*! 
*  \brief     ڵǰļĩβд
*  \param  buffer 
*  \param  dlc ݳ
*/
void SD_WriteFile(uint8 *buffer,uint16 dlc);

/*! 
*  \brief     ȡǰļ
*  \param  offset ļλƫ
*  \param  dlc ݳ
*/
void SD_ReadFile(uint32 offset,uint16 dlc);

/*! 
*  \brief     ȡǰļ
*/
void SD_GetFileSize();

/*! 
*  \brief     رյǰļ
*/
void SD_CloseFile();
#endif

/*! 
*  \brief     ¼ؼ-
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  value 澯ֵ
*  \param  time 澯ʱ䣬Ϊ0ʱʹĻڲʱ
*/
void Record_SetEvent(uint16 screen_id,uint16 control_id,uint16 value,uint8 *time);

/*! 
*  \brief     ¼ؼ-
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  value 澯ֵ
*  \param  time 澯ʱ䣬Ϊ0ʱʹĻڲʱ
*/
void Record_ResetEvent(uint16 screen_id,uint16 control_id,uint16 value,uint8 *time);

/*! 
*  \brief    ¼ؼ- ӳ¼
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  record һ¼(ַ)ֺͨŸ磺һ;ڶ;;
*/
void Record_Add(uint16 screen_id,uint16 control_id,uint8 *record);

/*! 
*  \brief     ¼ؼ-¼
*  \param  screen_id ID
*  \param  control_id ؼID
*/
void Record_Clear(uint16 screen_id,uint16 control_id);

/*! 
*  \brief     ¼ؼ-ü¼ʾƫ
*  \param  screen_id ID
*  \param  control_id ؼID
*  \param  offset ʾƫƣλ
*/
void Record_SetOffset(uint16 screen_id,uint16 control_id,uint16 offset);

/*! 
*  \brief     ¼ؼ-ȡǰ¼Ŀ
*  \param  screen_id ID
*  \param  control_id ؼID
*/
void Record_GetCount(uint16 screen_id,uint16 control_id);


/*! 
*  \brief     ȡĻRTCʱ
*/
void ReadRTC(void);

/*! 
*  \brief   
*  \param   buffer ʮƵ·
*/
void PlayMusic(uint8 *buffer);

#endif      //_HMI_DRIVER_
