/******************** (C) COPYRIGHT 2018 STMicroelectronics ********************
* File Name          : hw_config.c
* Author             : MCD Application Team
* Version            : V3.1.1
* Date               : 21/08/2018
* Description        : Hardware Configuration & Setup
********************************************************************************
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "stm32f10x_it.h"
#include "hw_config.h"


ErrorStatus HSEStartUpStatus;
/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/

USART_InitTypeDef USART_InitStructure;



/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/
/*******************************************************************************
* Function Name  : Set_System
* Description    : Configures Main system clocks & power
* Input          : None.
* Return         : None.
*******************************************************************************/
void Set_System(void)
{


    // SYSCLK, HCLK, PCLK2 and PCLK1 configuration 
    // RCC system reset(for debug purpose) 
    RCC_DeInit();
    //ʹڲľ
    RCC_HSICmd(ENABLE);
    while(RCC_GetFlagStatus(RCC_FLAG_HSIRDY) == RESET)
    {
    }
    if(1)
    {

        FLASH_PrefetchBufferCmd(FLASH_PrefetchBuffer_Enable);
        FLASH_SetLatency(FLASH_Latency_2);

        RCC_HCLKConfig(RCC_SYSCLK_Div1);                                 //AHBʱ

        RCC_PCLK2Config(RCC_HCLK_Div1);                                  //APB2ʱ

        RCC_PCLK1Config(RCC_HCLK_Div2);                                  //ABP1ʱ

        // PLL ʱԴƵϵ
        RCC_PLLConfig(RCC_PLLSource_HSI_Div2, RCC_PLLMul_12);            //4M*12 =48M


        //ʹܻʧ PLL,ȡENABLEDISABLE
        RCC_PLLCmd(ENABLE);//PLLϵͳʱ,ôܱʧ
        //ȴָ RCC ־λóɹ ȴPLLʼɹ
        while(RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET)
        {
        }

        //ϵͳʱӣSYSCLK PLLΪϵͳʱԴ
        RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);

        //ȴPLLɹϵͳʱӵʱԴ
        //  0x00HSI Ϊϵͳʱ
        //  0x04HSEΪϵͳʱ
        //  0x08PLLΪϵͳʱ
        while(RCC_GetSYSCLKSource() != 0x08)
        {
        }
    }
#
}



/*******************************************************************************
* Function Name  : USB_Interrupts_Config
* Description    : Configures the USB interrupts
* Input          : None.
* Return         : None.
*******************************************************************************/
void Interrupts_Config(void)
{
    NVIC_InitTypeDef NVIC_InitStructure;
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);
    /* Enable USART Interrupt */
    NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_Init(&NVIC_InitStructure);
}




/******************* (C) COPYRIGHT 2010 STMicroelectronics *****END OF FILE****/
